function [years, months, span, N, T_all, caputils, industry_names]=data_capu(NIND, excluded_assets)
    %% The purpose of this code is to import the capacity utilization data
    [data,names] = xlsread('data\data_CU.xls','caputil');
    data = data(8:end,:);
    years = data(:,1);
    months = data(:,2);

    % Clean up the data and check for errors in the import;
    span = data(:,1) + data(:,2)/12;
    T_all = size(span,1);
    caputils_all = data(:,3:end);

    % Look for errors in the number of industries;
    assert(size(caputils_all,2) == NIND);
    % Keep the industry names;
    industry_names_all = names(1,4:end);
    assert(size(industry_names_all,2) == NIND);

    % N defines the number of series that should be used in the analysis, where
    % N = Total Series - Excluded Series;
    N = size(caputils_all,2)-size(excluded_assets,1);

    caputils = zeros(size(caputils_all,1),N);
    industry_names = cell(N,1);
    
    % Put the data in the right place of the panel;
    j = 0;
    for i = 1:NIND
        if (size(find(excluded_assets == i),1)==0)
            j = j+1;
            caputils(:,j) = caputils_all(:,i);
            industry_names{j} = industry_names_all(i);
        end
    end
end

