function [portfolioChars, ColLabels_chars, RowLabels_chars, parentheses_chars]=data_chars(caputils,...
    span, ret_span, NIND, excluded_assets, portfolioAssignments,...
    N_PORTFOLIO, rets, lmvs, nfirms, start_date_sample)
    %% Reading in the industry characteristics data created in SAS;

    start_row = find(ret_span==start_date_sample);
    T_ret = size(ret_span,1);
    N = size(portfolioAssignments,2);
    AltportfolioAssignments = NaN(T_ret, N);
    AltportfolioAssignments(start_row:end,:)=portfolioAssignments;

    %Creating (initially) empty vectors to hold the raw data;
    at_g        = zeros(T_ret,N);
    beme        = zeros(T_ret,N);
    debt_growth = zeros(T_ret,N);
    EI_BE       = zeros(T_ret,N);
    gp_at       = zeros(T_ret,N);
    hire_rate   = zeros(T_ret,N);
    rnd_me      = zeros(T_ret,N);
    invt_g      = zeros(T_ret,N);
    inv_at      = zeros(T_ret,N);
    debt_at     = zeros(T_ret,N);
    ik          = zeros(T_ret,N);
    OC_AT       = zeros(T_ret,N);
    roa         = zeros(T_ret,N);
    TFP         = zeros(T_ret,N);
    ivol        = zeros(T_ret,N); 
    me          = zeros(T_ret,N);

    j = 0;
    for i = 1:NIND
        if (size(find(excluded_assets == i),1)==0)
            j = j+1;
            ind_data(j)=i; 
            data_ret = csvread(['Data/Industry-files/industry',num2str(i),'.csv']);
            data_ret(data_ret == -99) = NaN;

            nfirms(:,j)     = data_ret(:,5);
            at_g(:,j)       = data_ret(:,6);
            beme(:,j)       = data_ret(:,7);
            debt_growth(:,j)= data_ret(:,8);
            EI_BE(:,j)      = data_ret(:,9);
            gp_at(:,j)      = data_ret(:,10);
            hire_rate(:,j)  = data_ret(:,11);
            rnd_me(:,j)     = data_ret(:,12);
            invt_g(:,j)     = data_ret(:,13);
            inv_at(:,j)     = data_ret(:,14);
            debt_at(:,j)    = data_ret(:,15);
            ik(:,j)         = data_ret(:,16);
            OC_AT(:,j)      = data_ret(:,17);
            roa(:,j)        = data_ret(:,18);
            TFP(:,j)        = data_ret(:,19);
            ivol(:,j)       = data_ret(:,20);
            me(:,j)         = data_ret(:,21);
           
            assert(size(data_ret,1) == T_ret);
        end
    end
    caputil_level=caputils(find(span == ret_span(1)):find(span == ret_span(end)),:);  
    assert(size(AltportfolioAssignments,1) == size(ret_span,1));
    
    portfolioRets           = NaN(T_ret,N_PORTFOLIO);
    numPerPortfolio         = NaN(T_ret,N_PORTFOLIO);
    numIndPerPortfolio      = NaN(T_ret,N_PORTFOLIO);
    portfolio_caputil_level = NaN(T_ret,N_PORTFOLIO);
    portfolio_at_g          = NaN(T_ret,N_PORTFOLIO);
    portfolio_beme          = NaN(T_ret,N_PORTFOLIO);
    portfolio_debt_growth   = NaN(T_ret,N_PORTFOLIO); 
    portfolio_EI_BE         = NaN(T_ret,N_PORTFOLIO);
    portfolio_gp_at         = NaN(T_ret,N_PORTFOLIO);
    portfolio_hire_rate     = NaN(T_ret,N_PORTFOLIO);
    portfolio_rnd_me        = NaN(T_ret,N_PORTFOLIO);
    portfolio_invt_g        = NaN(T_ret,N_PORTFOLIO);
    portfolio_inv_at        = NaN(T_ret,N_PORTFOLIO);    
    portfolio_debt_at       = NaN(T_ret,N_PORTFOLIO);
    portfolio_ik            = NaN(T_ret,N_PORTFOLIO);
    portfolio_OC_AT         = NaN(T_ret,N_PORTFOLIO);       
    portfolio_roa           = NaN(T_ret,N_PORTFOLIO);    
    portfolio_TFP           = NaN(T_ret,N_PORTFOLIO);
    portfolio_ivol          = NaN(T_ret,N_PORTFOLIO);
    portfolio_me            = NaN(T_ret,N_PORTFOLIO);    

    for t = 2:T_ret
        if t<=T_ret
            for i = 1:N_PORTFOLIO

                rets_in_portfolio           = [];
                lmvs_in_portfolio           = [];
                nfirms_in_portfolio         = [];
                caputil_level_in_portfolio  = [];
                at_g_in_portfolio           = [];
                beme_in_portfolio           = [];
                debt_growth_in_portfolio    = [];
                EI_BE_in_portfolio          = [];
                gp_at_in_portfolio          = [];
                hire_rate_in_portfolio      = [];
                rnd_me_in_portfolio         = [];
                invt_g_in_portfolio         = [];
                inv_at_in_portfolio         = [];   
                debt_at_in_portfolio        = [];
                ik_in_portfolio             = [];
                roa_in_portfolio            = [];
                TFP_in_portfolio            = [];
                ivol_in_portfolio           = [];
                me_in_portfolio             = [];
                OC_AT_in_portfolio          = [];

                nan_count=0;
                for j = 1:N
                    if (AltportfolioAssignments(t,j) == i)
                        if (isnan(rets(t,j)) || isnan(lmvs(t,j)))
                            continue;
                        end
                        lmvs_in_portfolio(end+1,1)          = lmvs(t,j);
                        rets_in_portfolio(end+1,1)          = rets(t,j);
                        nfirms_in_portfolio(end+1,1)        = nfirms(t,j);
                        caputil_level_in_portfolio(end+1,1) = caputil_level(t,j);
                        at_g_in_portfolio(end+1,1)          = at_g(t,j);
                        beme_in_portfolio(end+1,1)          = beme(t,j);
                        debt_growth_in_portfolio(end+1,1)   = debt_growth(t,j);
                        EI_BE_in_portfolio(end+1,1)         = EI_BE(t,j);                        
                        gp_at_in_portfolio(end+1,1)         = gp_at(t,j);
                        hire_rate_in_portfolio(end+1,1)     = hire_rate(t,j);
                        rnd_me_in_portfolio(end+1,1)        = rnd_me(t,j);
                        invt_g_in_portfolio(end+1,1)        = invt_g(t,j);
                        inv_at_in_portfolio(end+1,1)        = inv_at(t,j); 
                        debt_at_in_portfolio(end+1,1)       = debt_at(t,j);
                        ik_in_portfolio(end+1,1)            = ik(t,j);
                        OC_AT_in_portfolio(end+1,1)         = OC_AT(t,j);
                        roa_in_portfolio(end+1,1)           = roa(t,j);
                        TFP_in_portfolio(end+1,1)           = TFP(t,j);
                        ivol_in_portfolio(end+1,1)          = ivol(t,j);
                        me_in_portfolio(end+1,1)            = me(t,j);
                    elseif isnan(AltportfolioAssignments(t,j))
                        nan_count=nan_count+1;
                    end
                end

                portfolio_caputil_level(t,i)= nanmean(caputil_level_in_portfolio);
                portfolios_nfirms(t,i)      = nansum(nfirms_in_portfolio);
                numIndPerPortfolio(t,i)     = sum(~isnan(nfirms_in_portfolio));
                portfolio_at_g(t,i)         = nanmean(at_g_in_portfolio);
                portfolio_beme(t,i)         = nanmean(beme_in_portfolio);
                portfolio_debt_growth(t,i)  = nanmean(debt_growth_in_portfolio);
                portfolio_EI_BE(t,i)        = nanmean(EI_BE_in_portfolio);
                portfolio_gp_at(t,i)        = nanmean(gp_at_in_portfolio);
                portfolio_hire_rate(t,i)    = nanmean(hire_rate_in_portfolio);
                portfolio_rnd_me(t,i)       = nanmean(rnd_me_in_portfolio);
                portfolio_invt_g(t,i)       = nanmean(invt_g_in_portfolio);
                portfolio_inv_at(t,i)       = nanmean(inv_at_in_portfolio); 
                portfolio_debt_at(t,i)      = nanmean(debt_at_in_portfolio);
                portfolio_ik(t,i)           = nanmean(ik_in_portfolio);
                portfolio_OC_AT(t,i)        = nanmean(OC_AT_in_portfolio);
                portfolio_roa(t,i)          = nanmean(roa_in_portfolio);
                portfolio_TFP(t,i)          = nanmean(TFP_in_portfolio);
                portfolio_ivol(t,i)         = nanmean(ivol_in_portfolio);
                portfolio_me(t,i)           = nanmean(me_in_portfolio); 
            end
        end
    end
    
    %Only want to keep the observations from each July of portfolio formation years;
    for i = 1:N_PORTFOLIO
        row_index=0;
        for t=7:12:T_ret
            row_index=row_index+1;
            portfolio_caputil_level_temp(row_index,i)   = portfolio_caputil_level(t,i);
            portfolio_nfirms_temp(row_index,i)          = portfolios_nfirms(t,i);
            portfolio_nind_temp(row_index,i)            = numIndPerPortfolio(t,i);
            portfolio_at_g_temp(row_index,i)            = portfolio_at_g(t,i);
            portfolio_beme_temp(row_index,i)            = portfolio_beme(t,i);
            portfolio_debt_growth_temp(row_index,i)     = portfolio_debt_growth(t,i);
            portfolio_EI_BE_temp(row_index,i)           = portfolio_EI_BE(t,i);  
            portfolio_GP_AT_temp(row_index,i)           = portfolio_gp_at(t,i);
            portfolio_hire_rate_temp(row_index,i)       = portfolio_hire_rate(t,i);
            portfolio_invt_g_temp(row_index,i)          = portfolio_invt_g(t,i);
            portfolio_rnd_me_temp(row_index,i)          = portfolio_rnd_me(t,i);
            portfolio_inv_at_temp(row_index,i)          = portfolio_inv_at(t,i);   
            portfolio_debt_at_temp(row_index,i)         = portfolio_debt_at(t,i);
            portfolio_ik_temp(row_index,i)              = portfolio_ik(t,i);
            portfolio_OC_AT_temp(row_index,i)           = portfolio_OC_AT(t,i);
            portfolio_roa_temp(row_index,i)             = portfolio_roa(t,i);
            portfolio_TFP_temp(row_index,i)             = portfolio_TFP(t,i);
            portfolio_ivol_temp(row_index,i)            = portfolio_ivol(t,i);
            portfolio_me_temp(row_index,i)              = portfolio_me(t,i);
        end
    end
    portfolioChars = NaN(19,N_PORTFOLIO+2);
    HAC_chars=1;
    for i=1:19
        if i==1
            temp_series=portfolio_caputil_level_temp;           
        elseif i==2
            temp_series=portfolio_nfirms_temp;    
        elseif i==3
            temp_series=portfolio_nind_temp;
        elseif i==4
            temp_series=portfolio_at_g_temp;
        elseif i==5
            temp_series=portfolio_beme_temp;
        elseif i==6
            temp_series=portfolio_debt_growth_temp;
        elseif i==7
            temp_series=portfolio_EI_BE_temp;
        elseif i==8
            temp_series=portfolio_GP_AT_temp;
        elseif i==9
            temp_series=portfolio_hire_rate_temp;
        elseif i==10
            temp_series=portfolio_invt_g_temp;
        elseif i==11
            temp_series=portfolio_rnd_me_temp;
        elseif i==12
            temp_series=portfolio_inv_at_temp;
        elseif i==13
            temp_series=portfolio_debt_at_temp;
        elseif i==14
            temp_series=portfolio_ik_temp;
        elseif i==15
            temp_series=portfolio_OC_AT_temp;
        elseif i==16
            temp_series=portfolio_roa_temp;
        elseif i==17
            temp_series=portfolio_TFP_temp; 
        elseif i==18
            temp_series=portfolio_ivol_temp;   
        elseif i==19
            temp_series=portfolio_me_temp;   
        end             
        for t=1:size(temp_series,1)
            if isempty(find(t==(7:12:size(temp_series,1))))
                temp_series(t,:)=NaN;
            end 
        end
        temp_series=temp_series(~any(isnan(temp_series),2),:); 
        portfolioChars(i,1:N_PORTFOLIO)=mean(temp_series);
        portfolioChars(i,N_PORTFOLIO+1)=portfolioChars(i,1)-portfolioChars(i,N_PORTFOLIO);
        spread_statistics = ols(temp_series(:,1)-temp_series(:,end),ones(size(temp_series,1),1),HAC_chars);
        portfolioChars(i,N_PORTFOLIO+2)=spread_statistics.tstat(1,1);
    end
    RowLabels_chars=cell(1,size(portfolioChars,1));
    ColLabels_chars=cell(1,size(portfolioChars,2));
    col_index=0;
    for r=1:size(portfolioChars,2)
        col_index=col_index+1;
        if r==1
            ColLabels_chars{1,r}=['Low'];
        elseif r==N_PORTFOLIO
            ColLabels_chars{1,r}=['High'];
        elseif r==N_PORTFOLIO+1
            ColLabels_chars{1,r}=['Low - High'];
        elseif r==N_PORTFOLIO+2
            ColLabels_chars{1,r}=['t-statistic'];
        else
            ColLabels_chars{1,r}=[num2str(col_index)];
        end
    end
    RowLabels_chars{1}=['CU (\%)'];
    RowLabels_chars{2}=['Num. firms'];
    RowLabels_chars{3}=['Num. Ind'];
    RowLabels_chars{4}=['Asset growth (\%)'];
    RowLabels_chars{5}=['BEME'];
    RowLabels_chars{6}=['Debt growth (\%)'];
    RowLabels_chars{7}=['Equity Issue. / BE'];
    RowLabels_chars{8}=['GP/A'];
    RowLabels_chars{9}=['Hire Rate'];  
    RowLabels_chars{10}=['R\&D/ME ($\times 10^4$)']; 
    RowLabels_chars{11}=['INVT growth (\%)'];
    RowLabels_chars{12}=['INV/A'];
    RowLabels_chars{13}=['Debt / Assets'];
    RowLabels_chars{14}=['I/K'];
    RowLabels_chars{15}=['Org. Capital / Assets'];
    RowLabels_chars{16}=['ROA'];
    RowLabels_chars{17}=['TFP'];
    RowLabels_chars{18}=['IVOL (\%)'];
    RowLabels_chars{19}=['ME'];
    parentheses_chars=zeros(size(portfolioChars,1),size(portfolioChars,2));
    parentheses_chars(:,end)=1;
end

