function [portfolioRets]=port_retsCU(VW, lmvs,...
    N_PORTFOLIO, nfirms, portfolioAssignments, rets, retxs, ret_span, start_date_sample)

    lmvs = lmvs(find(ret_span == start_date_sample):find(ret_span == ret_span(end)),:);
    rets = rets(find(ret_span == start_date_sample):find(ret_span == ret_span(end)),:);
    retxs = retxs(find(ret_span == start_date_sample):find(ret_span == ret_span(end)),:);
    nfirms = nfirms(find(ret_span == start_date_sample):find(ret_span == ret_span(end)),:);
    T_ret=size(portfolioAssignments,1);
    N = size(portfolioAssignments,2);

    portfolioRets = NaN(T_ret,N_PORTFOLIO);
    portfolioRetxs = NaN(T_ret,N_PORTFOLIO);
    
    numPerPortfolio = NaN(T_ret,N_PORTFOLIO);

    for t = 1:T_ret
        for i = 1:N_PORTFOLIO
            rets_in_portfolio = [];
            retxs_in_portfolio = [];
            lmvs_in_portfolio = [];
            nfirms_in_portfolio = [];
            nan_count = 0;
            for j = 1:N
                if (portfolioAssignments(t,j) == i)
                   if (isnan(rets(t,j)) || isnan(lmvs(t,j)))
                       continue;
                   end
                   rets_in_portfolio(end+1,1) = rets(t,j);
                   retxs_in_portfolio(end+1,1) = retxs(t,j);
                   lmvs_in_portfolio(end+1,1) = lmvs(t,j);
                   nfirms_in_portfolio(end+1,1) = nfirms(t,j);
                elseif isnan(portfolioAssignments(t,j))
                    nan_count = nan_count+1;
                end
            end
            if nan_count == N
                continue
            elseif VW==1
                portfolioRets(t,i)  = rets_in_portfolio'*(lmvs_in_portfolio./sum(lmvs_in_portfolio));
                portfolioRetxs(t,i) = retxs_in_portfolio'*(lmvs_in_portfolio./sum(lmvs_in_portfolio));
            else
                portfolioRets(t,i)  = mean(rets_in_portfolio);
                portfolioRets(t,i)  = mean(retxs_in_portfolio);
            end
            numPerPortfolio(t,i) = size(rets_in_portfolio,1);
        end
    end
end