function dataOut = winsor(dataIn,alpha)
    % The purpose of this code is to winsorize a dataset at a given level of
    % alpha (e.g. 1% is equivalent to alpha = 0.01);

    dataInTemp = dataIn(:);
    dataInTemp(isnan(dataInTemp)) = [];
    data_min = prctile(dataInTemp,100*alpha);
    dataIn(dataIn < data_min) = data_min;
    data_max = prctile(dataInTemp,100-(100*alpha));
    dataIn(dataIn > data_max) = data_max;
    dataOut = dataIn;
end

