%% Reproduce Table 6

load Output\CALIBATION_PARAMETERS
tid = fopen('..\TablesAndFigures\Table_6.tex', 'w+'); 
fprintf(tid, '\\begin{tabularx}{\\textwidth}{@{\\extracolsep{\\fill}}lll c lll} \n');
fprintf(tid, '\\toprule \n ');
fprintf(tid, '\\hline \n');
fprintf(tid, '\\text{Symbol} & \\text{Description} & \\text{Value}& &\\text{Symbol} & \\text{Description} & \\text{Value}  \\\\\n');
fprintf(tid, '\\midrule \n');
fprintf(tid, '\\multicolumn{3}{l}{Stochastic processes} & & \\multicolumn{3}{l}{Technology} \\\\\n');
fprintf(tid, '$\\rho_{x}$ & Persistence of agg. productivity & %2.3f & & $\\alpha_{k}$ & Capital share & %2.3f \\\\\n',...
    CALIBATION_PARAMETERS(1), CALIBATION_PARAMETERS(9));
fprintf(tid, '$\\sigma_{x}$ & Volatility of agg. productivity & %2.3f & & $\\alpha_{l}$ & Labor share & %2.3f \\\\\n',...
    CALIBATION_PARAMETERS(2), CALIBATION_PARAMETERS(10));
fprintf(tid, '$\\bar{z}$ & Average of idio. productivity & %2.3f & & $\\theta$ & Returns to scale & %2.3f  \\\\\n',...
    CALIBATION_PARAMETERS(5), CALIBATION_PARAMETERS(11));
fprintf(tid, '$\\rho_{z}$ & Persistence of idio. productivity & %2.3f & & $\\delta_{k}$ & Fixed capital dep. rate & %2.3f \\\\\n',...
    CALIBATION_PARAMETERS(3), CALIBATION_PARAMETERS(12));
fprintf(tid, '$\\sigma_{z}$ & Volatility of idio. productivity & %2.3f & & $\\delta_{u}$ & Variable dep. rate & %2.3f \\\\\n',...
    CALIBATION_PARAMETERS(4), CALIBATION_PARAMETERS(13));
fprintf(tid, '$\\beta$ & Time discount factor & %2.3f & & $\\lambda$ & Elasticity of dep. & %2.3f  \\\\\n',...
    CALIBATION_PARAMETERS(6), CALIBATION_PARAMETERS(14));
fprintf(tid, '$\\gamma_{0}$ & Constant price of risk &  %2.3f & & $\\omega$ & Wage sensitivity & %2.3f \\\\\n',...
    CALIBATION_PARAMETERS(7), CALIBATION_PARAMETERS(15));
fprintf(tid, '$\\gamma_{1}$ & Time-varying price of risk & %2.3f & & $\\phi$ & Adjustment cost & %2.2f \\\\\n',...
    CALIBATION_PARAMETERS(8), CALIBATION_PARAMETERS(16));
fprintf(tid, '\\multicolumn{3}{l}{ } & & 	$f$ & Fixed cost parameter & %2.2f \\\\\n', CALIBATION_PARAMETERS(17));
fprintf(tid, '\\bottomrule \n');
fprintf(tid, '\\end{tabularx} \n');
fclose(tid);

%% Reproduce Table 7

% Load the baseline calibration
load Output\MOMENT_1.mat

tid = fopen('..\TablesAndFigures\Table_7.tex', 'w+'); 
fprintf(tid, '\\begin{tabularx}{\\textwidth}{@{\\extracolsep{\\fill}} llcc } \n');
fprintf(tid, '\\toprule \n ');
fprintf(tid, '\\hline \n');
fprintf(tid, '\\text{Variable} & & \\text{Data} & \\text{Model} \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{4}{c}{Panel A: \\text{Real quantities}}\\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, 'Volatility of firm-level investment rate (time-series) & & %2.2f & %2.2f \\\\\n',0.14,MOMENT(4,1));
fprintf(tid, 'Volatility of firm-level investment rate (cross-sectional) & & %2.2f & %2.2f \\\\\n',0.16,MOMENT(4,2));
fprintf(tid, 'AC(1) of firm-level investment rate & & %2.2f & %2.2f \\\\\n',0.52,MOMENT(5,1));
fprintf(tid, 'AC(2) of firm-level investment rate & & %2.2f & %2.2f \\\\\n',0.26,MOMENT(5,2));
fprintf(tid, 'Skewness of firm-level investment rate (time-series) & & %2.2f & %2.2f \\\\\n',0.67,MOMENT(6,1));
fprintf(tid, 'Skewness of firm-level investment rate (cross-sectional) & & %2.2f & %2.2f \\\\\n',1.89,MOMENT(6,2));
fprintf(tid, 'Inter-decile range of investment rate & & %2.2f & %2.2f \\\\\n',0.32,MOMENT(10,1));
fprintf(tid, 'Volatility of aggregate capacity utilization level & & %2.2f & %2.2f \\\\\n',4.09,MOMENT(3,1));
fprintf(tid, 'Autocorrelation of aggregate capacity utilization level & & %2.2f & %2.2f \\\\\n',0.65,MOMENT(3,2));
fprintf(tid, 'Volatility of aggregate sales growth & & %2.2f & %2.2f \\\\\n',6.58,MOMENT(20,1));
fprintf(tid, 'Autocorrelation of aggregate sales growth & & %2.2f & %2.2f \\\\\n',0.46,MOMENT(21,1));
fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{4}{c}{Panel B: \\text{Asset prices}}\\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, 'Real risk-free rate & & %2.2f & %2.2f  \\\\\n',1.19,MOMENT(1,1)*100);
fprintf(tid, 'Excess market return & & %2.2f & %2.2f \\\\\n',6.28,MOMENT(2,1)*100);
fprintf(tid, 'Volatility of excess market return & & %2.2f & %2.2f \\\\\n',17.20,MOMENT(2,2)*100);
fprintf(tid, 'Autocorrelation of excess market return & & %2.2f & %2.2f \\\\\n',-0.05,MOMENT(2,3));
fprintf(tid, 'Book-to-market spread & & %2.2f & %2.2f \\\\\n',3.71,MOMENT(11,1)*-1);
fprintf(tid, 'Investment spread & & %2.2f & %2.2f \\\\\n',3.70,MOMENT(11,2));
fprintf(tid, '\\bottomrule \n');
fprintf(tid, '\\end{tabularx} \n');
fclose(tid);

%% Reproducing Table 8

% Load the baseline firm-level calibrations
LSFirm = load('Output\MOMENT_1.mat');
SSFirm = load('Output\MOMENT_2.mat');
SSInd = load('Output\MOMENT_IND_3.mat');
LSInd = load('Output\MOMENT_IND_4.mat');
tid = fopen('..\TablesAndFigures\Table_8.tex', 'w+'); 
fprintf(tid, '\\begin{tabularx}{\\textwidth}{@{\\extracolsep{\\fill}} llcccc } \n');
fprintf(tid, '\\toprule \n');
fprintf(tid, '\\hline \n');
fprintf(tid, ' & & \\multicolumn{2}{c}{Population} & & Short sample \\\\\n');
fprintf(tid, '\\cline{3-4} \\cline{6-6}\n');
fprintf(tid, 'Portfolio & & $E\\left[R^{CU}\\right]$ & $\\beta$ & & $E\\left[R^{CU}\\right]$ \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{6}{c}{Panel A: Industry-level analysis} \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, 'Low (L) & & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',       LSInd.MOMENT_IND(3,1), LSInd.MOMENT_IND(13,1), SSInd.MOMENT_IND(3,1), SSInd.MOMENT_IND(3,2), SSInd.MOMENT_IND(3,3)); 
fprintf(tid, 'Medium  & & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',       LSInd.MOMENT_IND(4,1), LSInd.MOMENT_IND(14,1), SSInd.MOMENT_IND(4,1), SSInd.MOMENT_IND(4,2), SSInd.MOMENT_IND(4,3)); 
fprintf(tid, 'High (H)& & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',       LSInd.MOMENT_IND(5,1), LSInd.MOMENT_IND(15,1), SSInd.MOMENT_IND(5,1), SSInd.MOMENT_IND(5,2), SSInd.MOMENT_IND(5,3)); 
fprintf(tid, 'Spread (L-H) & & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',  LSInd.MOMENT_IND(6,1), LSInd.MOMENT_IND(16,1), SSInd.MOMENT_IND(6,1), SSInd.MOMENT_IND(6,2), SSInd.MOMENT_IND(6,3)); 
fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{6}{c}{Panel B: Firm-level analysis} \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, 'Low (L) & & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',       LSFirm.MOMENT(12,1), LSFirm.MOMENT(16,1), SSFirm.MOMENT(12,1), SSFirm.MOMENT(12,2), SSFirm.MOMENT(12,3)); 
fprintf(tid, 'Medium  & & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n'  ,     LSFirm.MOMENT(13,1), LSFirm.MOMENT(17,1), SSFirm.MOMENT(13,1), SSFirm.MOMENT(13,2), SSFirm.MOMENT(13,3)); 
fprintf(tid, 'High (H)& & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',       LSFirm.MOMENT(14,1), LSFirm.MOMENT(18,1), SSFirm.MOMENT(14,1), SSFirm.MOMENT(14,2), SSFirm.MOMENT(14,3)); 
fprintf(tid, 'Spread (L-H)& & %2.2f & %2.2f & & %2.2f [%2.2f, %2.2f] \\\\\n',   LSFirm.MOMENT(15,1), LSFirm.MOMENT(19,1), SSFirm.MOMENT(15,1), SSFirm.MOMENT(15,2), SSFirm.MOMENT(15,3)); 
fprintf(tid, '\\bottomrule \n');
fprintf(tid, '\\end{tabularx} \n');
fclose(tid);

%% Reproducing Table 9
Cal1=load('Output\MOMENT_1.mat');
Cal5=load('Output\MOMENT_5.mat');
Cal6=load('Output\MOMENT_6.mat');
Cal7=load('Output\MOMENT_7.mat');
Cal8=load('Output\MOMENT_8.mat');
Cal9=load('Output\MOMENT_9.mat');
Cal10=load('Output\MOMENT_10.mat');
Cal11=load('Output\MOMENT_11.mat');
Cal12=load('Output\MOMENT_12.mat');
Cal13=load('Output\MOMENT_13.mat');
Cal14=load('Output\MOMENT_14.mat');
Cal15=load('Output\MOMENT_15.mat');
Cal16=load('Output\MOMENT_16.mat');
Cal17=load('Output\MOMENT_17.mat');
load CALIBRATION

tid = fopen('..\TablesAndFigures\Table_9.tex', 'w+'); 
fprintf(tid, '\\scalebox{0.90}{ \n');
fprintf(tid, '\\footnotesize \n');
fprintf(tid, '\\begin{tabularx}{\\textwidth}{@{\\extracolsep{\\fill}} ll cccc c cc c cc } \n');
fprintf(tid, '\\toprule \n');
fprintf(tid, '\\hline \n');
fprintf(tid, ' & & \\multicolumn{4}{c}{Time-series} & & \\multicolumn{2}{c}{Cross-sectional} & & \\multicolumn{2}{c}{Risk premia} \\\\\n');
fprintf(tid, '\\cline{3-6} \\cline{8-9} \\cline{11-12}  \n');
fprintf(tid, 'Row & \\text{Model} & $\\sigma_{TS}\\left(ik\\right)$ & $S_{TS}\\left(ik\\right)$ & $\\rho_{1}\\left(ik\\right)$ & $\\sigma\\left(u\\right)$ &  & $\\sigma_{CS}\\left(ik\\right)$ & $S_{CS}\\left(ik\\right)$ & & $E\\left[R^{bm}\\right]$ & $E\\left[R^{ik}\\right]$  \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '& \\multicolumn{11}{l}{Data} \\\\\n');
fprintf(tid, ' & & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', 0.14, 0.67,...
    0.52,4.09, 0.16, 1.89, 3.71, 3.70);
fprintf(tid, ' & & & & & & & & & & & \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{12}{c}{Panel A: Sensitivity to utilization ($\\lambda$)} \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '& \\multicolumn{11}{l}{Baseline without utilization} \\\\\n');
fprintf(tid, '(1) & \\multicolumn{1}{l}{\\quad ($\\lambda \\rightarrow \\infty$)} & %2.2f & %2.2f & %2.2f & - & & %2.2f & %2.2f & & %2.2f & %2.2f  \\\\\n', Cal5.MOMENT(4,1), Cal5.MOMENT(6,1), Cal5.MOMENT(5,1), Cal5.MOMENT(4,2),Cal5.MOMENT(6,2), Cal5.MOMENT(11,1)*-1, Cal5.MOMENT(11,2));
fprintf(tid, ' & & & & & & & & & & & \\\\\n');
fprintf(tid, '& \\multicolumn{11}{l}{Baseline} \\\\\n');
fprintf(tid, '(2) & \\multicolumn{1}{l}{\\quad ($\\lambda = 3$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', Cal1.MOMENT(4,1), Cal1.MOMENT(6,1), Cal1.MOMENT(5,1),Cal1.MOMENT(3,1), Cal1.MOMENT(4,2), Cal1.MOMENT(6,2), Cal1.MOMENT(11,1)*-1, Cal1.MOMENT(11,2));
fprintf(tid, ' & & & & & & & & & & & \\\\\n');
fprintf(tid, '& \\multicolumn{11}{l}{Different $\\lambda$} \\\\\n');
fprintf(tid, '(3) & \\multicolumn{1}{l}{\\quad Very low ($\\lambda=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(3,6), Cal6.MOMENT(4,1), Cal6.MOMENT(6,1), Cal6.MOMENT(5,1), Cal6.MOMENT(3,1), Cal6.MOMENT(4,2), Cal6.MOMENT(6,2), Cal6.MOMENT(11,1)*-1, Cal6.MOMENT(11,2));
fprintf(tid, '(4) & \\multicolumn{1}{l}{\\quad Low ($\\lambda=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(3,7), Cal7.MOMENT(4,1), Cal7.MOMENT(6,1), Cal7.MOMENT(5,1), Cal7.MOMENT(3,1), Cal7.MOMENT(4,2), Cal7.MOMENT(6,2), Cal7.MOMENT(11,1)*-1, Cal7.MOMENT(11,2));
fprintf(tid, '(5) & \\multicolumn{1}{l}{\\quad High ($\\lambda=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f& & %2.2f & %2.2f \\\\\n',CALIBRATION(3,8), Cal8.MOMENT(4,1), Cal8.MOMENT(6,1), Cal8.MOMENT(5,1), Cal8.MOMENT(3,1), Cal8.MOMENT(4,2), Cal8.MOMENT(6,2), Cal8.MOMENT(11,1)*-1, Cal8.MOMENT(11,2));
fprintf(tid, '(6) & \\multicolumn{1}{l}{\\quad Very high ($\\lambda=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(3,9), Cal9.MOMENT(4,1), Cal9.MOMENT(6,1), Cal9.MOMENT(5,1), Cal9.MOMENT(3,1), Cal9.MOMENT(4,2), Cal9.MOMENT(6,2), Cal9.MOMENT(11,1)*-1, Cal9.MOMENT(11,2));

fprintf(tid, '\\hline \n');
fprintf(tid, '\\multicolumn{12}{c}{Panel B: Sensitivity to adjustment costs ($\\phi$)} \\\\\n');
fprintf(tid, '\\hline \n');
fprintf(tid, '& \\multicolumn{11}{l}{Different $\\phi$ and fixed utilization} \\\\\n');
fprintf(tid, '(7) & \\multicolumn{1}{l}{\\quad Very low ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & -& & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(2,10), Cal10.MOMENT(4,1), Cal10.MOMENT(6,1), Cal10.MOMENT(5,1), Cal10.MOMENT(5,2),Cal10.MOMENT(6,2), Cal10.MOMENT(11,1)*-1, Cal10.MOMENT(11,2));
fprintf(tid, '(8) & \\multicolumn{1}{l}{\\quad Low ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & -& & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', 1.4,   Cal11.MOMENT(4,1), Cal11.MOMENT(6,1), Cal11.MOMENT(5,1), Cal11.MOMENT(5,2),Cal11.MOMENT(6,2), Cal11.MOMENT(11,1)*-1, Cal11.MOMENT(11,2));
fprintf(tid, '(9) & \\multicolumn{1}{l}{\\quad High ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & -& & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', 1.6,  Cal12.MOMENT(4,1), Cal12.MOMENT(6,1), Cal12.MOMENT(5,1), Cal12.MOMENT(5,2),Cal12.MOMENT(6,2), Cal12.MOMENT(11,1)*-1, Cal12.MOMENT(11,2));
fprintf(tid, '(10) & \\multicolumn{1}{l}{\\quad Very high ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & -& & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(2,13), Cal13.MOMENT(4,1), Cal13.MOMENT(6,1), Cal13.MOMENT(5,1), Cal13.MOMENT(5,2),Cal13.MOMENT(6,2), Cal13.MOMENT(11,1)*-1, Cal13.MOMENT(11,2));
fprintf(tid, ' & & & & & & & & & & & \\\\\n');
fprintf(tid, '& \\multicolumn{11}{l}{Different $\\phi$ and flexible utilization} \\\\\n');
fprintf(tid, '(11) & \\multicolumn{1}{l}{\\quad Very low ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(2,14), Cal14.MOMENT(4,1), Cal14.MOMENT(6,1), Cal14.MOMENT(5,1), Cal14.MOMENT(3,1), Cal14.MOMENT(4,2), Cal14.MOMENT(6,2), Cal14.MOMENT(11,1)*-1, Cal14.MOMENT(11,2));
fprintf(tid, '(12) & \\multicolumn{1}{l}{\\quad Low ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(2,15), Cal15.MOMENT(4,1), Cal15.MOMENT(6,1), Cal15.MOMENT(5,1), Cal15.MOMENT(3,1), Cal15.MOMENT(4,2), Cal15.MOMENT(6,2), Cal15.MOMENT(11,1)*-1, Cal15.MOMENT(11,2));
fprintf(tid, '(13) & \\multicolumn{1}{l}{\\quad High ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f  & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n',CALIBRATION(2,16),Cal16.MOMENT(4,1), Cal16.MOMENT(6,1), Cal16.MOMENT(5,1),Cal16.MOMENT(3,1), Cal16.MOMENT(4,2), Cal16.MOMENT(6,2),  Cal16.MOMENT(11,1)*-1, Cal16.MOMENT(11,2));
fprintf(tid, '(14) & \\multicolumn{1}{l}{\\quad Very high ($\\phi=%2.2f$)} & %2.2f & %2.2f & %2.2f & %2.2f & & %2.2f & %2.2f & & %2.2f & %2.2f \\\\\n', CALIBRATION(2,17), Cal17.MOMENT(4,1), Cal17.MOMENT(6,1), Cal17.MOMENT(5,1), Cal17.MOMENT(3,1), Cal17.MOMENT(4,2), Cal17.MOMENT(6,2), Cal17.MOMENT(11,1)*-1, Cal17.MOMENT(11,2));
fprintf(tid, '\\bottomrule \n');
fprintf(tid, '\\end{tabularx} \n');
fprintf(tid, '\\normalsize \n');
fprintf(tid, '} \n');
fclose(tid);

PLOT_FLAG = 0;
if PLOT_FLAG == 1
    plot_figure;
end
