%%%
% The function implements Tauchen (1986)
% author: Gill Segal, The Wharton School
%%%
function [P] = Tauchen(mu, rho, sigma, grid)
    N = size(grid,1);
    P = zeros(N,N);
    for i = 1:N
        for j = 1:N
            if (j==1)
                P(i,j) = normcdf((grid(1)+(grid(2)-grid(1))/2-rho*grid(i)-mu)/(sigma), 0, 1);
            elseif (j==N)
                P(i,j) = 1-normcdf((grid(N)-(grid(N)-grid(N-1))/2-rho*grid(i)-mu)/(sigma), 0, 1);
            else

                P(i,j) = normcdf(((grid(j)+grid(j+1))/2-rho*grid(i)-mu)/(sigma), 0, 1) - ...
                                normcdf(((grid(j)+grid(j-1))/2-rho*grid(i)-mu)/(sigma), 0, 1);
            end
        end
        P(i,:) = P(i,:)/sum(P(i,:));
    end
end

