function [zss, delta_u] = deterministicSS_FC(a0, beta, delta_k, omega, eta,...
    gamma_0, gamma_1, alpha_k, alpha_l, zeta, sigma_a)

	gamma   = gamma_0 + gamma_1*a0; 
	gk      = 0;                    
	q       = log(1+gk);            
	k       = 0;                    
	Z0 = ones(3,1);                 
	tt = 18; 
	[Z,fval] = fsolve(@(Z) dss_FC(Z, alpha_k, alpha_l, delta_k,...
	                              beta, omega, eta, gamma, sigma_a, a0, k),...
	                              Z0, optimset('TolX',10^(-tt-2),...
	                              'TolFun',10^(-tt),'MaxFunEvals',1000000,...
	                              'MaxIter',100000,...
	                              'algorithm','Levenberg-Marquardt'));
	Z = real(Z);
	Z 		= real(Z);
	i    	= Z(1);            
	z0   	= Z(2);            
	l    	= Z(3);            
	ik   	= log(i/exp(k));   
	m 		= log(beta);
	g_k 	= 0.5*eta*( 0 )^2 * exp(k);
	q_k 	= log(1+g_k);   
	MP_k 	= log( exp(a0)*exp(z0)*alpha_k*exp(k)^(alpha_k-1)*exp(l)^(alpha_l) );
	MP_l 	= log( exp(a0)*exp(z0)*exp(k)^(alpha_k)*alpha_l*exp(l)^(alpha_l-1) );
	w 		= omega * a0;
	r_k     = log((exp(MP_k)+(1-delta_k)*exp(q_k)+0.5*eta*(exp(ik)^2-delta_k^2))/exp(q_k));
	y   	= log( exp(a0)*exp(z0)*exp(k)^(alpha_k)*exp(l)^(alpha_l) );
	div 	= exp(y) - i- g_k - exp(l)*exp(w);
	v   	= log(div/(1-exp(m)));
	u = 0;
	dydut0 	= log(exp(a0)*exp(z0)*alpha_k*exp(k)*exp(k)^(alpha_k-1)*exp(l)^(alpha_l));
	delta_u = exp(dydut0)/exp(k);

	zss = z0;

end

