% This code plots figure one of the paper. The data required to plot the
% figure is contained in K_FC_U.mat which holds:
% (1) Capital and depreciation policies from solving the baseline model
% without the fixed cost;
% (2) Capital and depreciation polocies from solving the baseline model
% with the fixed cost;
% (3) Capital policy from solving the model without utilization;
% (4) The structure also contains k_grid, the z_grid, and zss

load Output/K_FC_U
N_A = 5;
delta_k = 0.08;

% The figure plots the investment rate of the median firm from a
% long-sample simulation of each model, holding aggregate productivity as
% its mean value;

p=plot(z_grid-zss, (k_grid(POLICY_K_mat_noFC(275,floor((N_A+1)/2),:))-(1-squeeze(POLICY_D_mat_noFC(275,floor((N_A+1)/2),:)))*k_grid(275))/k_grid(275),...
    z_grid-zss, (k_grid(POLICY_K_mat_FC(274,floor((N_A+1)/2),:))-(1-squeeze(POLICY_D_mat_FC(274,floor((N_A+1)/2),:)))*k_grid(274))/k_grid(274),...
    z_grid-zss, (k_grid(POLICY_K_mat_FC_NoU(237,floor((N_A+1)/2),:))-(1-delta_k)*k_grid(237))/k_grid(237));
set(p(1),'linestyle','-.','color','red');
set(p(2),'linestyle','-','color','blue');
set(p(3),'linestyle','--','color','black');
ylabel('\textbf{Investment rate (I/K)}','interpreter','latex','FontSize',16);
xlabel('\textbf{Idiosyncratic productivity ($z$)}','interpreter','latex','FontSize',16);
xlim([-0.51 0.11]);
leg=legend('No fixed cost ($f=0$)','Benchmark','Fixed utilization ($\lambda \rightarrow +\infty$)','location','southeast');
grid(gca,'minor');
grid on
set(leg,'Interpreter','latex','fontsize',12);
set(gcf, 'Color', 'w');
saveas(gcf, ['..\TablesAndFigures\Figure_1.eps'],'epsc');
saveas(gcf, ['..\TablesAndFigures\Figure_1.png']);      
