% tic                                   
M_MAX       = CALIBRATION(4,s);         
breakpoint_percentiles = [10; 90];
RM_MEAN     = zeros(M_MAX,1);   
RM_VOL      = zeros(M_MAX,1);  
TRUNC       = 200;                      
T           = CALIBRATION(5,s)+TRUNC;   
CS          = CALIBRATION(6,s);         

RM_ACF      = zeros(M_MAX,1);   
RF_MEAN     = zeros(M_MAX,1);   
OUTPUT_VOL  = zeros(M_MAX,1);   
OUTPUT_AC1  = zeros(M_MAX,1);   
IK_MEAN     = zeros(M_MAX,1);   
IK_STD      = zeros(M_MAX,1);   
IK_CORR1    = zeros(M_MAX,1);   
IK_CORR2    = zeros(M_MAX,1);   
IK_SKEW     = zeros(M_MAX,1);   
IK_SKEW_CS  = zeros(M_MAX,1);   
IK_STD_CS   = zeros(M_MAX,1);   
IKD         = zeros(M_MAX,1);   

MKT_UTIL_STD    = zeros(M_MAX,1);  
MKT_UTIL_ACF    = zeros(M_MAX,1);   
MKT_OUTPUT_STD  = zeros(M_MAX,1); 

portRet_MEANVW      = zeros(M_MAX,size(breakpoint_percentiles,1)+2);
portBeta_MEANVW     = zeros(M_MAX,size(breakpoint_percentiles,1)+2);
portRet_MEANIK      = zeros(M_MAX,size(breakpoint_percentiles,1)+2);
portRet_MEANBM      = zeros(M_MAX,size(breakpoint_percentiles,1)+2);

% Loop over the Monte Carlo simulations;
for m=1:M_MAX
    sim_seed = RandStream.create('mrg32k3a','Seed',m+23);
    fprintf('monte carlo number: %3.0f\n',m);
    shockAgg = rand(sim_seed,T,1);      
    pathAgg = zeros(T,1);               
    pathAgg(1,1) = floor((N_A+1)/2);   
    lastAggShock = pathAgg(1,1);        

    for t = 2:T
       temp=cumsum(P_a(lastAggShock,:));    
       if shockAgg(t)<=temp(1)              
           pathAgg(t,1)=1;
       elseif shockAgg(t)>temp(N_A)
           pathAgg(t,1)= N_A;
       else
           pathAgg(t,1)=find(shockAgg(t)<=temp(2:N_A) & shockAgg(t)>temp(1:(N_A)-1))+1; 
       end
       lastAggShock = pathAgg(t);
    end
    V_CS      = zeros(T,CS);
    Div_CS    = zeros(T,CS);
    Output_CS = zeros(T,CS);
    IK_CS     = zeros(T,CS);
    Retex_CS  = zeros(T,CS);
    Ret_CS    = zeros(T,CS);
    Util_CS   = zeros(T,CS);
    RfPath    = zeros(T,1);
    BM_CS     = zeros(T,CS);

    for i_cs = 1:CS
        if mod(i_cs,1000)==0
            fprintf('Up to stock number: %d \n',i_cs)
        end
        lastZInd = floor((N_Z+1)/2);
        lastKInd = floor((N_K+1)/2);
        shockIdio = rand(sim_seed,T,1);
        for t = 2:T
                temp=cumsum(P_z(lastZInd,:));
                currShock = shockIdio(t,1);
                if currShock<=temp(1)
                   currZInd=1;
                elseif currShock>temp(N_Z)
                   currZInd= N_Z;
                else
                   currZInd=find(currShock<=temp(2:N_Z) & currShock>temp(1:(N_Z)-1))+1; 
                end
                exoState = pathAgg(t,1) + (currZInd - 1)*N_A;
                stateInd = lastKInd + (exoState-1)*N_K;
                currKInd = POLICY_K(stateInd); 
                RfPath(t,1)      = Rf(exoState,1);  
                IK_CS(t,i_cs)    = investment(stateInd,POLICY_K(stateInd))/k_grid(lastKInd);
                Util_CS(t,i_cs)     = utilization(stateInd);
                Output_CS(t,i_cs)   = output(stateInd);
                V_CS(t,i_cs)        = V(stateInd);
                BM_CS(t,i_cs)       = k_grid(lastKInd) / V(stateInd);
                Div_CS(t,i_cs)      = div(stateInd,POLICY_K(stateInd));
                Ret_CS(t,i_cs)      = log(V_CS(t,i_cs)/(V_CS(t-1,i_cs)-Div_CS(t-1,i_cs)))*(5/3);
                Retex_CS(t,i_cs)    = log(V_CS(t,i_cs)/(V_CS(t-1,i_cs)-Div_CS(t-1,i_cs)))*(5/3)-RfPath(t-1,1);
                lastZInd = currZInd;
                lastKInd = currKInd;
        end 
    end
    V_CS         = V_CS(TRUNC+1:end,:);
    Div_CS       = Div_CS(TRUNC+1:end,:);
    IK_CS        = IK_CS(TRUNC+1:end,:);
    Retex_CS     = Retex_CS(TRUNC+1:end,:);
    Ret_CS       = Ret_CS(TRUNC+1:end,:);         
    Util_CS      = Util_CS(TRUNC+1:end,:)*100;    %
    RfPath       = RfPath(TRUNC+1:end,1);
    BM_CS        = BM_CS(TRUNC+1:end,:);
    Output_CS    = Output_CS(TRUNC+1:end,:);
    W_CS = zeros(size(V_CS,1),size(V_CS,2));
    for t = 1:size(W_CS,1)
        W_CS(t,:) = V_CS(t,:)/sum(V_CS(t,:));
    end
    curr_rm_path = sum(W_CS(1:end-1,:).*Retex_CS(2:end,:),2);
    % Adding a NaN since we lose one obsrvation in the previous step;
    curr_rm_path = [NaN; curr_rm_path];
    agg_output = nansum(W_CS(1:end-1,:).*winsor(Output_CS(2:end,:),0.05),2)./nansum(W_CS(1:end-1,:),2);
    agg_output_growth = log(agg_output(2:end)./agg_output(1:end-1))*100;
    agg_output_ACF = autocorr(agg_output_growth);      
    
    aShockPathCU = curr_rm_path;
    aShockPathCU = aShockPathCU * (0.172 / nanstd(aShockPathCU));
        
    if FIX_UTIL == 0
        UnivSortUtil =  univariate_sort(Util_CS,Ret_CS,...
            [10 90]',W_CS);
        UnivRetsUtil = univariate_ports(UnivSortUtil,RfPath,aShockPathCU);
        LMH_CU = UnivSortUtil.PortRetsVW(2:end,1)-UnivSortUtil.PortRetsVW(2:end,3);
        portRet_MEANVW(m,:)   = UnivRetsUtil.CAPM_VW(:,1)'*100;
        portBeta_MEANVW(m,:)  = UnivRetsUtil.CAPM_VW(:,3)';      
    end
            
    UnivSortBM =  univariate_sort(BM_CS,Ret_CS,...
        [20 80]',W_CS);
    UnivRetsBM = univariate_ports(UnivSortBM,RfPath,aShockPathCU);
    HHML_BM = UnivSortBM.PortRetsVW(2:end,3)-UnivSortBM.PortRetsVW(2:end,1);
    portRet_MEANBM(m,:)   = UnivRetsBM.CAPM_VW(:,1)'*100; 
    
    UnivSortIK =  univariate_sort(IK_CS,Ret_CS,...
        [20 80]',W_CS);
    UnivRetsIK = univariate_ports(UnivSortIK,RfPath,aShockPathCU);
    LMH_IK = UnivSortIK.PortRetsVW(2:end,1)-UnivSortIK.PortRetsVW(2:end,3);
    portRet_MEANIK(m,:)   = UnivRetsIK.CAPM_VW(:,1)'*100;
    
    breakpoint_percentiles = [10; 90];
    N_BP            = size(breakpoint_percentiles,1);
    RF_MEAN(m,1)    = mean(RfPath);               
    RM_MEAN(m,1)    = nanmean(curr_rm_path);
    RM_VOL(m,1)     = nanstd(curr_rm_path);
    RM_ACF_temp     = autocorr(curr_rm_path,1);
    RM_ACF(m,1)     = RM_ACF_temp(2);
    OUTPUT_VOL(m,1)  = std(agg_output_growth);   
    OUTPUT_AC1(m,1)  = agg_output_ACF(2);     
    if FIX_UTIL == 0
        MKT_UTIL            = sum(W_CS(1:end-1,:).*Util_CS(2:end,:),2);
        MKT_UTIL_STD(m,1)   = std(MKT_UTIL);
        temp                = autocorr(MKT_UTIL,2);
        MKT_UTIL_ACF(m,1)   = temp(2);
    end
             
    ikstds      = zeros(CS,1);
    ikcorr1     = zeros(CS,1);
    ikcorr2     = zeros(CS,1);
    ikskew      = zeros(CS,1);
    ikskewcs    = zeros(size(CS,1),1);
    ikstdcs     = zeros(size(CS,1),1);
    ikd         = zeros(T,1);
    ikiqr       = zeros(T,1);
                      
    for i_cs = 1:CS
        ikstds(i_cs,1)  = std(IK_CS(:,i_cs));
        ikskew(i_cs,1)  = skewness(IK_CS(:,i_cs));
        ikcorr1(i_cs,1) = corr(IK_CS(2:end,i_cs),IK_CS(1:end-1,i_cs));
        ikcorr2(i_cs,1) = corr(IK_CS(3:end,i_cs),IK_CS(1:end-2,i_cs));
    end
    
    for t=1:size(IK_CS,1)
       ikskewcs(t) = skewness(IK_CS(t,:)); 
       ikstdcs(t)  = std(IK_CS(t,:));
       ikd(t)      = prctile(IK_CS(t,:),90)-prctile(IK_CS(t,:),10);
    end
        
    IK_STD(m,1)     = mean(ikstds);
    IK_STD_CS(m,1)  = mean(ikstdcs);
    IK_CORR1(m,1)   = mean(ikcorr1);
    IK_CORR2(m,1)   = mean(ikcorr2);
    IK_SKEW(m,1)    = mean(ikskew);
    IK_SKEW_CS(m,1) = mean(ikskewcs);  
    IKD(m,1)        = mean(ikd);
    
    toc
    fprintf('\n\n');
end
    
% Reporting summary statistics for the portfolio returns;
PERC = 5;

% NEED TO SAVE MOMENTS TO OUTPUT AND CREATE TABLES;
MOMENT = NaN(21,3);
MOMENT(1,1) = mean(RF_MEAN);
MOMENT(2,1) = mean(RM_MEAN);                MOMENT(2,2) = mean(RM_VOL);                     MOMENT(2,3) = mean(RM_ACF);               
MOMENT(3,1) = mean(MKT_UTIL_STD);           MOMENT(3,2) = mean(MKT_UTIL_ACF);              
MOMENT(4,1) = mean(IK_STD);                 MOMENT(4,2) = mean(IK_STD_CS); 
MOMENT(5,1) = mean(IK_CORR1);               MOMENT(5,2) = mean(IK_CORR2);                           
MOMENT(6,1) = mean(IK_SKEW);                MOMENT(6,2) = mean(IK_SKEW_CS);
MOMENT(10,1) = mean(IKD);                  
MOMENT(11,1) = mean(portRet_MEANBM(:,end));  MOMENT(11,2)= mean(portRet_MEANIK(:,end));
MOMENT(12,1) = mean(portRet_MEANVW(:,1));    MOMENT(12,2) = prctile(portRet_MEANVW(:,1),PERC);    MOMENT(12,3) = prctile(portRet_MEANVW(:,1),100-PERC);
MOMENT(13,1) = mean(portRet_MEANVW(:,2));    MOMENT(13,2) = prctile(portRet_MEANVW(:,2),PERC);    MOMENT(13,3) = prctile(portRet_MEANVW(:,2),100-PERC);
MOMENT(14,1) = mean(portRet_MEANVW(:,3));    MOMENT(14,2) = prctile(portRet_MEANVW(:,3),PERC);    MOMENT(14,3) = prctile(portRet_MEANVW(:,3),100-PERC);
MOMENT(15,1) = mean(portRet_MEANVW(:,end));  MOMENT(15,2) = prctile(portRet_MEANVW(:,end),PERC);  MOMENT(15,3) = prctile(portRet_MEANVW(:,end),100-PERC);
MOMENT(16,1) = mean(portBeta_MEANVW(:,1));   MOMENT(16,2) = prctile(portBeta_MEANVW(:,1),PERC);   MOMENT(16,3) = prctile(portBeta_MEANVW(:,1),100-PERC);
MOMENT(17,1) = mean(portBeta_MEANVW(:,2));   MOMENT(17,2) = prctile(portBeta_MEANVW(:,2),PERC);   MOMENT(17,3) = prctile(portBeta_MEANVW(:,2),100-PERC);
MOMENT(18,1) = mean(portBeta_MEANVW(:,3));   MOMENT(18,2) = prctile(portBeta_MEANVW(:,3),PERC);   MOMENT(18,3) = prctile(portBeta_MEANVW(:,3),100-PERC);
MOMENT(19,1) = mean(portBeta_MEANVW(:,end)); MOMENT(19,2) = prctile(portBeta_MEANVW(:,end),PERC); MOMENT(19,3) = prctile(portBeta_MEANVW(:,end),100-PERC);
MOMENT(20,1) = mean(OUTPUT_VOL);             MOMENT(20,2) = prctile(OUTPUT_VOL,PERC);             MOMENT(20,3) = prctile(OUTPUT_VOL,100-PERC);
MOMENT(21,1) = mean(OUTPUT_AC1);             MOMENT(21,2) = prctile(OUTPUT_AC1,PERC);             MOMENT(21,3) = prctile(OUTPUT_AC1,100-PERC);

save(['Output/MOMENT_',num2str(s)],'MOMENT');