M_MAX       = CALIBRATION(4,s);         
TRUNC       = 200;                     
T           = CALIBRATION(5,s)+1+TRUNC;         
SORTS       = 0; 
size_ind    = 100;

breakpoint_percentiles = [10; 90];
portRet_MEANVW    = zeros(M_MAX,size(breakpoint_percentiles,1)+2);
portAlpha_MEANVW  = zeros(M_MAX,size(breakpoint_percentiles,1)+2);
portBeta_MEANVW   = zeros(M_MAX,size(breakpoint_percentiles,1)+2);

corr_ind    = 0.5;
IND = 50; 
% Loop over the Monte Carlo simulations;
for m=1:M_MAX
    sim_seed = RandStream.create('mrg32k3a','Seed',m+23);
    if mod(m,10)==0
        fprintf('monte carlo number: %3.0f\n',m);
    end
    shockAgg = rand(sim_seed,T,1);               
    pathAgg = zeros(T,1);               
    pathAgg(1,1) = floor((N_A+1)/2);    
    lastAggShock = pathAgg(1,1);        
    for t = 2:T
       temp=cumsum(P_a(lastAggShock,:));   
       if shockAgg(t)<=temp(1)              
           pathAgg(t,1)=1;
       elseif shockAgg(t)>temp(N_A)
           pathAgg(t,1)= N_A;
       else
           pathAgg(t,1)=find(shockAgg(t)<=temp(2:N_A) & shockAgg(t)>temp(1:(N_A)-1))+1; 
       end
       lastAggShock = pathAgg(t);
    end
    RET_IND     = zeros(T-TRUNC,IND);
    RETEX_IND   = zeros(T-TRUNC,IND);
    UTIL_IND    = zeros(T-TRUNC,IND);
    W_IND       = zeros(T-TRUNC,IND);
    RfPath      = zeros(T,1);

    for i_ind = 1:IND
        if mod(i_ind,10)==0
            fprintf('Up to industry number: %d \n',i_ind)
        end
        
        V_CS      = zeros(T,size_ind);
        Util_CS   = zeros(T,size_ind);
        Retex_CS  = zeros(T,size_ind);
        Ret_CS    = zeros(T,size_ind); 
        Z_CS      = zeros(T,size_ind);
        Div_CS    = zeros(T,size_ind);

        if size_ind>1
            % Creating "firms" within the industry;
            SIGMA = eye(size_ind);
            SIGN = (2*randi(sim_seed,[0 1],size_ind)-1);
            SHIFT = rand(sim_seed,size_ind,size_ind);
            OffDiagonal = repmat(corr_ind,size_ind,size_ind)+(SIGN.*SHIFT.*corr_ind*0.1);
            SIGMA(SIGMA==0) = OffDiagonal(SIGMA==0);
            SIGMA = (SIGMA+SIGMA')/2;
            L = chol(SIGMA);
            Z = L'*randn(sim_seed,size_ind,T);
            Z = Z';
        end
        for i_cs = 1:size_ind
            lastZInd = floor((N_Z+1)/2);
            lastKInd = floor((N_K+1)/2);
            if size_ind > 1
                shockIdio = Z(:,i_cs);
                shockIdio = 0.5*erfc(-shockIdio/sqrt(2));
            else
                shockIdio = rand(sim_seed,T,1);
            end
            for t = 2:T
                temp=cumsum(P_z(lastZInd,:));
                currShock = shockIdio(t,1);
                if currShock<=temp(1)
                   currZInd=1;
                elseif currShock>temp(N_Z)
                   currZInd= N_Z;
                else
                   currZInd=find(currShock<=temp(2:N_Z) & currShock>temp(1:(N_Z)-1))+1; 
                end
                exoState = pathAgg(t,1) + (currZInd - 1)*N_A;
                stateInd = lastKInd + (exoState-1)*N_K;
                currKInd = POLICY_K(stateInd);
                RfPath(t,1)      = Rf(exoState,1);  
                Util_CS(t,i_cs)     = utilization(stateInd);
                V_CS(t,i_cs)        = V(stateInd);
                Div_CS(t,i_cs)      = div(stateInd,POLICY_K(stateInd));
                Retex_CS(t,i_cs)    = (log(V_CS(t,i_cs)/(V_CS(t-1,i_cs)-Div_CS(t-1,i_cs))-RfPath(t-1,1))*(5/3));
                Ret_CS(t,i_cs)      = (log(V_CS(t,i_cs)/(V_CS(t-1,i_cs)-Div_CS(t-1,i_cs)))*(5/3)); 
                lastZInd = currZInd;
                lastKInd = currKInd;
            end
        end
        Div_CS       = Div_CS(TRUNC:end,:);
        Retex_CS     = Retex_CS(TRUNC:end,:);
        Ret_CS       = Ret_CS(TRUNC:end,:);     
        Util_CS      = Util_CS(TRUNC:end,:)*100;   
        V_CS         = V_CS(TRUNC:end,:);                
        RfPath       = RfPath(TRUNC+1:end,1);
        W_CS = zeros(size(Ret_CS,1),size(Ret_CS,2));
        for t = 1:size(W_CS,1)
            W_CS(t,:) = V_CS(t,:)/sum(V_CS(t,:));
        end
        W_CS_Raw = V_CS;
        
        curr_ret        = nansum(W_CS(1:end-1,:).*Ret_CS(2:end,:),2);
        curr_retex      = nansum(W_CS(1:end-1,:).*Retex_CS(2:end,:),2); 
        curr_UTIL       = nansum(W_CS(1:end-1,:).*Util_CS(2:end,:),2); 
        W_IND(:,i_ind)  = nansum(W_CS_Raw(2:end,:),2);

        RET_IND(:,i_ind)    = curr_ret;
        RETEX_IND(:,i_ind)  = curr_retex;
        UTIL_IND(:,i_ind)   = curr_UTIL;
        W_IND(:,i_ind) = nansum(W_CS_Raw(1:end-1,:),2);
    end

    W_IND           = W_IND./nansum(W_IND,2);
    curr_rm_path    = nansum(W_IND.*RETEX_IND,2);
    aShockPathCU = curr_rm_path * (0.172 / std(curr_rm_path));
    
    UnivSortUtil =  univariate_sort(UTIL_IND,RET_IND,...
        [10 90]',W_IND);
    UnivRetsUtil = univariate_ports(UnivSortUtil,RfPath,aShockPathCU);
    LMH_CU = UnivSortUtil.PortRetsVW(2:end,1)-UnivSortUtil.PortRetsVW(2:end,3);
    portRet_MEANVW(m,:)   = UnivRetsUtil.CAPM_VW(:,1)'*100;
    portBeta_MEANVW(m,:)  = UnivRetsUtil.CAPM_VW(:,3)';  
end
       
PERC = 5;
MOMENT_IND = NaN(23,3);
MOMENT_IND(1,1) = IND; MOMENT_IND(1,2) = size_ind; MOMENT_IND(1,3) = corr_ind;
MOMENT_IND(3,1) = mean(portRet_MEANVW(:,1));       MOMENT_IND(3,2) = prctile(portRet_MEANVW(:,1),PERC);          MOMENT_IND(3,3) = prctile(portRet_MEANVW(:,1),100-PERC);
MOMENT_IND(4,1) = mean(portRet_MEANVW(:,2));       MOMENT_IND(4,2) = prctile(portRet_MEANVW(:,2),PERC);          MOMENT_IND(4,3) = prctile(portRet_MEANVW(:,2),100-PERC);
MOMENT_IND(5,1) = mean(portRet_MEANVW(:,3));       MOMENT_IND(5,2) = prctile(portRet_MEANVW(:,3),PERC);          MOMENT_IND(5,3) = prctile(portRet_MEANVW(:,3),100-PERC);
MOMENT_IND(6,1) = mean(portRet_MEANVW(:,end));     MOMENT_IND(6,2) = prctile(portRet_MEANVW(:,end),PERC);        MOMENT_IND(6,3) = prctile(portRet_MEANVW(:,end),100-PERC);
MOMENT_IND(13,1) = mean(portBeta_MEANVW(:,1));     MOMENT_IND(13,2) = prctile(portBeta_MEANVW(:,1),PERC);        MOMENT_IND(13,3) = prctile(portBeta_MEANVW(:,1),100-PERC);
MOMENT_IND(14,1) = mean(portBeta_MEANVW(:,2));     MOMENT_IND(14,2) = prctile(portBeta_MEANVW(:,2),PERC);        MOMENT_IND(14,3) = prctile(portBeta_MEANVW(:,2),100-PERC);
MOMENT_IND(15,1) = mean(portBeta_MEANVW(:,3));     MOMENT_IND(15,2) = prctile(portBeta_MEANVW(:,3),PERC);        MOMENT_IND(15,3) = prctile(portBeta_MEANVW(:,3),100-PERC);
MOMENT_IND(16,1) = mean(portBeta_MEANVW(:,end));   MOMENT_IND(16,2) = prctile(portBeta_MEANVW(:,end),PERC);      MOMENT_IND(16,3) = prctile(portBeta_MEANVW(:,end),100-PERC);
save(['Output/MOMENT_IND_',num2str(s)],'MOMENT_IND');

function [L, DMC, P, D] = modchol_ldlt(A,delta)
%modchol_ldlt  Modified Cholesky algorithm based on LDL' factorization.
%   [L D,P,D0] = modchol_ldlt(A,delta) computes a modified
%   Cholesky factorization P*(A + E)*P' = L*D*L', where 
%   P is a permutation matrix, L is unit lower triangular,
%   and D is block diagonal and positive definite with 1-by-1 and 2-by-2 
%   diagonal blocks.  Thus A+E is symmetric positive definite, but E is
%   not explicitly computed.  Also returned is a block diagonal D0 such
%   that P*A*P' = L*D0*L'.  If A is sufficiently positive definite then 
%   E = 0 and D = D0.  
%   The algorithm sets the smallest eigenvalue of D to the tolerance
%   delta, which defaults to sqrt(eps)*norm(A,'fro').
%   The LDL' factorization is compute using a symmetric form of rook 
%   pivoting proposed by Ashcraft, Grimes and Lewis.

%   Reference:
%   S. H. Cheng and N. J. Higham. A modified Cholesky algorithm based
%   on a symmetric indefinite factorization. SIAM J. Matrix Anal. Appl.,
%   19(4):1097-1110, 1998. doi:10.1137/S0895479896302898,

%   Authors: Bobby Cheng and Nick Higham, 1996; revised 2015.

if ~ishermitian(A), error('Must supply symmetric matrix.'), end
if nargin < 2, delta = sqrt(eps)*norm(A,'fro'); end

n = max(size(A));

[L,D,p] = ldl(A,'vector'); 
DMC = eye(n);

% Modified Cholesky perturbations.
k = 1;
while k <= n

      if k == n || D(k,k+1) == 0 % 1-by-1 block

         if D(k,k) <= delta
            DMC(k,k) = delta;
         else
            DMC(k,k) = D(k,k);
         end
         k = k+1;
      
      else % 2-by-2 block

         E = D(k:k+1,k:k+1);
         [U,T] = eig(E);
         for ii = 1:2
             if T(ii,ii) <= delta
                T(ii,ii) = delta;
             end
         end
         temp = U*T*U';
         DMC(k:k+1,k:k+1) = (temp + temp')/2;  % Ensure symmetric.
         k = k + 2;

      end

end

if nargout >= 3, P = eye(n); P = P(p,:); end
end